var gateway = `ws://${window.location.hostname}/ws`;
var websocket;

// Initialization
window.addEventListener('load', onLoad);

function onLoad(event) {
    initWebSocket();
    initButton();
}

// WebSocket handling
function initWebSocket() {
    console.log('Trying to open a WebSocket connection...');
    websocket = new WebSocket(gateway);
    websocket.onopen    = onOpen;
    websocket.onclose   = onClose;
    websocket.onmessage = onMessage;
}

function onOpen(event) {
    console.log('Connection opened');
}

function onClose(event) {
    console.log('Connection closed');
    setTimeout(initWebSocket, 2000);
}

function onMessage(event) {
    let data = JSON.parse(event.data);
    document.getElementById('led').className = data.status;
}

let hours = document.getElementById("hours");
let minutes = document.getElementById("minutes");
let seconds = document.getElementById("seconds");

function updateTime() {
	let date = new Date();
  if (date.getHours()>12){ 
	  hours.innerText = date.getHours() % 12;
    meridian.innerText = "PM";
  } else{
    hours.innerText = date.getHours();
    meridian.innerText = "AM";
  }
	// Add leading zero to minutes if necessary
  if (date.getMinutes() < 10) {
    minutes.innerText = "0" + date.getMinutes();
``} else{
    minutes.innerText = date.getMinutes();
  }
  // Add leading zero to seconds if necessary
  if (date.getSeconds() < 10) {
    seconds.innerText = "0" + date.getSeconds();
``} else{
    seconds.innerText = date.getSeconds();
  }

}
setInterval(updateTime, 1000);

var data_status = "Waiting";
document.getElementById("data_status").innerHTML = data_status;
var button_text = "Click to Recieve Data";
document.getElementById("button_text").innerHTML = button_text;
var temp = new Array(5000);
var data = new Array(5000);
var labels = new Array(5000);
for(let i=0; i<5000; i++) {
  labels[i]=i;
}

function recieveArray(){
  fetch('/temp.txt')
  .then(response => response.text())
  .then(jsonString => {
    const data = JSON.parse(jsonString);
    let i=0;
    data.forEach(value => {
      const div = document.createElement('div');
      div.textContent = value;
      temp[i]=value;
      i++;
    });
    document.getElementById("temp").innerHTML = temp;
    data = temp;
  });
  
}

let mydata;
function recieveHR(){
  fetch('/heartRate.json')
  .then(response => response.json())
  .then(data => {
      mydata = data;
    });
}


let mydata2;
function recieveSPO2(){
  fetch('/SPO2.json')
  .then(response => response.json())
  .then(data => {
      mydata2 = data;
    });
}

function recieveData(){
  recieveArray();
  timestamp();
  document.getElementById("timestamp").style.display = "block";
  document.getElementById("open_graph").style.display = "block";
  recieveHR();
  button_text = "Click to view HR and SPO2";
  document.getElementById("button_text").innerHTML = button_text;
  data_status = "Recieved All Data";
  document.getElementById("data_status").innerHTML = data_status;
  recieveSPO2();
  document.getElementById("HR").innerHTML = mydata.value;
  document.getElementById("SPO2").innerHTML = mydata2.value;
  document.getElementById("button_text").innerHTML = "All data Recived";
  document.getElementById("button_text").style.backgroundImage = "linear-gradient(#f8f9fa, #e9ecef)";
  document.getElementById("button_text").style.color = "black";
  document.getElementById("button_text").style.textShadow = "none";
  document.getElementById("message").style.display = "block"
}

let stamp_hours = document.getElementById("stamp_hours");
let stamp_minutes = document.getElementById("stamp_minutes");
let stamp_seconds = document.getElementById("stamp_seconds");
let stamp_meridian = document.getElementById("stamp_meridian");
function timestamp(){
  let date = new Date();
  if (date.getHours()>12){ 
	  stamp_hours.innerText = date.getHours() % 12;
    stamp_meridian.innerText = "PM";
  } else{
    stamp_hours.innerText = date.getHours();
    stamp_meridian.innerText = "AM";
  }
	// Add leading zero to minutes if necessary
  if (date.getMinutes() < 10) {
    stamp_minutes.innerText = "0" + date.getMinutes();
``} else{
    stamp_minutes.innerText = date.getMinutes();
  }
  // Add leading zero to seconds if necessary
  if (date.getSeconds() < 10) {
    stamp_seconds.innerText = "0" + date.getSeconds();
``} else{
    stamp_seconds.innerText = date.getSeconds();
  }

}

function openGraphs(){

let graph1 = new Chart(document.getElementById("ECG"), {
      type: "line",
      data: {
        labels: labels,
        datasets: [
          {
            label: "ECG Samples",
            data: temp,
            borderColor: "red",
            fill: true,
          },
        ],
      },
      options : {
        scales: {
          y: {
            display: false,
            title: {
              display: false,
              text: 'voltage'
            }
          },
          x: {
            title: {
              display: true,
              text: 'ms'
            }
          }
        }     
      }
    });
  document.getElementById("open_graph").innerHTML = "Graphs opened";
  document.getElementById("open_graph").style.backgroundImage = "linear-gradient(#f8f9fa, #e9ecef)";
  document.getElementById("open_graph").style.color = "black";
  document.getElementById("open_graph").style.textShadow = "none";
  //document.getElementById("reset").style.display = "block";
  }

  /*function resetFiles(){
    document.getElementById("timestamp").style.display = "none";
    document.getElementById("open_graph").style.display = "none";
    data_status = "Waiting";
    document.getElementById("data_status").innerHTML = data_status;
    button_text = "Click to Recieve Data";
    document.getElementById("button_text").innerHTML = button_text;
    document.getElementById("HR").innerHTML = "";
    document.getElementById("SPO2").innerHTML = "";
    document.getElementById("ECG").style.display = "none";
    document.getElementById("button_text").style.backgroundImage = "linear-gradient(#2e3538, #73848c)";
    document.getElementById("button_text").style.color = "white";
    document.getElementById("button_text").style.textShadow = "0 -1px 1px #000";
    document.getElementById("open_graph").innerHTML = "Graphs opened";
    document.getElementById("open_graph").style.backgroundImage = "linear-gradient(#2e3538, #73848c)";
    document.getElementById("open_graph").style.color = "white";
    document.getElementById("open_graph").style.textShadow = "0 -1px 1px #000";
    
    
    document.getElementById("reset").style.display = "none";
  }*/
